;   ---------------------------------------------------------------------------
.macro	FP
		mov 	r16,	@0	;@0 -   
		mov	r17,	@2	;@2 -  
		bst	r16,	@1	;@1 -     
		bld	r16,	0	;   
		bst	r17,	@3	;@3 -  
		bld	r17,	0	;    
		ldi	r18,	1<<0	;    
		eor	r16,	r18	;   
		and	r17,	r16
		bst	@2,	@3	;      
		bld	@0,	@1	;       . 
		bst	r17,	0	;    
		
.endm
;   -----------------------------------------------------------------------------
.macro	FN
		mov 	r16,	@0	;@0 -   
		mov	r17,	@2	;@2 -  
		bst	r16,	@1	;@1 -     
		bld	r16,	0	;   
		bst	r17,	@3	;@3 -  
		bld	r17,	0	;    
		ldi	r18,	1<<0	;    
		eor	r17,	r18	;   
		and	r17,	r16
		bst	@2,	@3	;      
		bld	@0,	@1	;       . 
		bst	r17,	0	;    
.endm
;     ---------------------------------------------------------------------------------
.macro	FN_
		ldi	r16,	1<<but
		mov	r17,	image
		mov	r18,	bef_im
		eor	r17,  	r16
		and	r17,	r18
		bst	r17,	but	;   
.endm
;     --------------------------------------------------------------------------------
.macro	FP_
		ldi	r16,	1<<but
		mov	r17, 	bef_im
		mov	r18,	image
		eor	r17,	r16
		and	r18,  	r17
		bst	r18,	but	;   
.endm
; ,  =1--------------------------------------------------------------------------------
.macro call_
		brtc PC+2
		rcall @0	;@0 -     
.endm


;    Down----------------------------------------------------------------------------------
.macro	Sleep_
		in	r16,	TCCR0A
		andi	r16,	~(3<<6)		; OC0A
		out	TCCR0A,	r16
		in	r16,	PORTB		
		ori	r16,	1<<0		;   0( )  
		out	PORTB,	r16		;   
		ldi	r16,	1<<INT0		; 
		out	GIMSK,	r16		;INT0
		sei				;  
		sleep
.endm
;  (  0,1 )-----------------------------------------------------------------------
.macro MainCount
;  ..........................................................................
	sbic	PINB,1
	rjmp	PC+4			;       
	cp 	len_coun,	R3	;R3=$FF       255
	breq	PC+2			;   
	add	len_coun,	r2	; 1 ( R2=1)
;  ..............................................................................
	sbis	PINB,1
	rjmp	PC+4			;       
	cp	len_del,	r3	
	breq	PC+2
	add	len_del,	r2	;  
.endm
;    -------------------------------------------------------
.macro	scan
		FN_		;   PINB.1( )
		brtc	PC+2	;   ( )  . .      .  .
		mov	len_coun,r1	;       (R1=0)
//   .....................................................
		cpi	len_coun, short_lim	;  
		brcs	PC+2	;     . 
		rcall	_ComLong	;   
//....................................................................
		FP_		;  ( )
		call_	sign ;   
		brtc	PC+2
		clr	len_del	
;		FN_		;  ( )
		rcall	del_sign	;  
.endm
; ------------------------------------------------------------------------------------
.macro	comm
		FP MF,0,  short,0 ;     
		brtc	PC+2	; . ,  =0
		add	temp_com, r2;  
		FP MF,2,  long,0 ;     
		brtc 	PC+2	;  =0
		mov	temp_com, r3 ;     $FF
		FN MF,1,  del,0	;     ( , )
		brtc	PC+3
		mov	command,temp_com
		mov	temp_com, r1
		mov	long,     r1	;  
		mov	short,    r1	;-//-
.endm
; --------------------------------------------------------------------------------------------
.macro	perform
		FN MF,4,  del,0
		brtc	perf_end
		mov	r16,	command
		cpi	r16,	com1
		brne	PC+2		;   . .   - 
		rcall	_com1		;    1
		cpi	r16,	com2
		brne	PC+2
		rcall	_com2		;    ,    2
//		cpi	r16,	com4
//		brne	PC+2
//		rcall	_com4		;-//-   4
//		cpi	r16,	ComLong
//		brne	PC+2	
//		rcall	_ComLong	;-//-  
perf_end:
.endm
; -----------------------------------------------------------------------------------------------
.macro	PWM_on
		in	r16,	TCCR0A
		ori	r16,	3<<6
		out	TCCR0A,	r16

.endm
; 15 .---------------------------------------------------------------------------------------------
.macro	TimeOut
		in	r16,	TCCR0A
		bst	r16,	com0a1	;  
		brtc	PC+2
		rcall	_TimeOut
.endm





































